version: "3.8"

services:
  db:
    image: "xivoxc/xivo-db:${XIVOCC_TAG}.${XIVOCC_DIST}"

    deploy:
      placement:
        constraints:
        - "node.labels.mds==${MDS_NAME}"

    environment:
    - IS_MDS=true
    - MDS_NAME
    - XIVO_NETWORK_SUBNET

    volumes:
    - /etc/timezone:/etc/timezone:ro
    - /etc/localtime:/etc/localtime:ro
    - /etc/passwd:/etc/passwd:ro
    - /etc/group:/etc/group:ro
    - /var/log/postgresql:/var/log/postgresql
    - /var/lib/postgresql/11:/var/lib/postgresql/11

    secrets:
    - pwd-db-asterisk

  confgend:
    image: xivoxc/xivo-confgend:${XIVOCC_TAG}.${XIVOCC_DIST}

    deploy:
      placement:
        constraints:
        - "node.labels.mds==${MDS_NAME}"

    environment:
    - MDS_NAME
    - IS_MDS=true

    secrets:
    - pwd-db-asterisk

  agid:
    image: "xivoxc/xivo-agid:${XIVOCC_TAG}.${XIVOCC_DIST}"

    deploy:
      placement:
        constraints:
        - "node.labels.mds==${MDS_NAME}"

    environment:
    - XIVO_UUID
    - XIVO_HOST

    volumes:
    - /etc/docker:/etc/docker
    - /etc/xivo:/etc/xivo

    secrets:
    - pwd-db-asterisk
    - accesswebservice-xivo-agid
    - play-auth-token
    - pwd-rabbitmq-guest

    configs:
    - source: cert-ca
      target: /docker-configs/cert-ca

  asterisk:
    image: "xivoxc/xivo-asterisk:${XIVOCC_TAG}.${XIVOCC_DIST}"

    deploy:
      placement:
        constraints:
        - "node.labels.mds==${MDS_NAME}"

    environment:
    - XCH_ADD_IP=${IPVLAN_ASTERISK_IP}

    networks:
    - default
    - voip_public

    logging:
      driver: local      

    configs:
    - source: ast-ami-xivo_agent
      target: /docker-configs/ast-ami-xivo_agent
    - source: ast-ami-xivo_amid
      target: /docker-configs/ast-ami-xivo_amid
    - source: ast-ami-xivo_cti_user
      target: /docker-configs/ast-ami-xivo_cti_user
    - source: ast-ami-xivo_provd
      target: /docker-configs/ast-ami-xivo_provd
    - source: ast-ami-xuc
      target: /docker-configs/ast-ami-xuc
    - source: ast-ari-conf
      target: /docker-configs/ast-ari-conf

networks:
  default:
    name: ${XIVO_NETWORK_NAME}
    external: true
  voip_public:
    external: true


secrets:
  pwd-db-asterisk:
    external: true
  accesswebservice-xivo-agid:
    external: true
  play-auth-token:
    external: true
  pwd-rabbitmq-guest:
    external: true

configs:
  cert-ca:
    external: true
  ast-ami-xivo_agent:
    external: true
  ast-ami-xivo_amid:
    external: true
  ast-ami-xivo_cti_user:
    external: true
  ast-ami-xivo_provd:
    external: true
  ast-ami-xuc:
    external: true
  ast-ari-conf:
    external: true
